; --------------------------------
;
;  Macros
;
; --------------------------------

WriteStr	 MACRO								 ; X, Y, COL, STR
						move.w	\3,-(a7)
						pea 		\4(PC)
						move.w	\2,-(a7)
						move.w	\1,-(a7)
						jsr romlib[puttext]
						lea 		10(a7),a7
					 ENDM

WriteChar  MACRO								 ; X, Y, COL, CHAR
						move.w	#$00FF,-(a7)
						move.w	#$0000,-(a7)
						move.w	#$00FF,-(a7)
						move.w	\3,-(a7)
						move.w	\2,-(a7)
						move.w	\1,-(a7)
						move.w	\4,-(a7)
						jsr romlib[putchar]
						lea 		14(a7),a7
					 ENDM

SetFont 	 MACRO								 ; FONT
						move.w	\1,-(a7)
						jsr romlib[set_font]
						lea 		2(a7),a7
					 ENDM

GetKeyStat MACRO								 ; ROW (0-9)
						move.w	#$FFFE,d0
						move.b	\1,d1
						rol.w 	d1,d0
						move.w	d0,($600018)
						nop
						nop
						nop
						nop
						move.b	($60001B),d0
					 ENDM

PutKeyLabel	MACRO			;X, Y, CHAR, STAT_VAR
	cmp.w		#1,\4
	beq		\4_on
	move.w		#4,d1
	bra		\4_off
\4_on:
	move.w		#0,d1
\4_off:
	WriteChar	\1,\2,d1,\3
					ENDM

Test_Sound	MACRO			;STAT_VAR, STAT_OFF_VALUE, FREQ
	cmp.w		\2,\1
	beq		\1_over
	jsr		romlib[reset_link]
	move.w		#$2700,sr	;Disable interrupts
	Sound		\3,#12
	move.w		#$2000,sr	;Enable interrupts
\1_over:
					ENDM

SWait	MACRO			; Waits \1 loops
 	move.l		d6,-(a7)
 	move.l		\1,d6
\waitloop:
 	dbra		d6,\waitloop
 	move.l		(a7)+,d6
					ENDM

Sound	MACRO			; \1=Freq  \2=Lenght
 	movem.l	d6-d7,-(a7)
 	move.l		\1,d6
 	move.l		\2,d7
 	bsr		Play
 	movem.l	(a7)+,d6-d7
					ENDM

Send	MACRO			; Sends a Byte through red and white
 	move.b  	\1,($60000E)
 	or.w		#%110000000000,($60000E)
					ENDM

Play:
 	Send		#100			; sends a byte with the size 100
 	SWait		d6
 	dbra		d7,Play			; do it d7 times
 	rts